'+--------------------------------------------------------------------------+
'|                               MovieBox                                   |
'|                                                                          |
'|                      Skin Engine for VISTA and XP                        |
'|           with full crystal and blur effect in composited mode           |
'|                                                                          |
'|                Example of what is going on behind the hood.              |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2007                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-04-2007 (MM-DD-YYYY)            |
'|                        Last revised : 02-24-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "MovieBox.exe"

'//DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO

#INCLUDE "ZSKIN.INC"

'------------------------------------------------------------------------------------------
' Movie section
'------------------------------------------------------------------------------------------
TYPE GUIDAPI
    Data1 AS DWORD
    Data2 AS WORD
    Data3 AS WORD
    Data4 AS STRING * 8
END TYPE

DECLARE FUNCTION CoCreateInstance LIB "ole32.dll" ALIAS "CoCreateInstance" (rclsid AS GUIDAPI, pUnkOuter AS ANY, BYVAL dwClsContext AS DWORD, riid AS GUIDAPI, ppv AS DWORD) AS LONG

$MOVIEXT              = ".avi.wmv.mpeg.mpg.mov.qt."
%OAFALSE              = 0
%OATRUE               = -1
%E_POINTER            = &H80004003
%CLSCTX_INPROC_SERVER = &H1???
%WM_MOVIENOTIFY       = %WM_USER + 13

'#INCLUDE "ActiveMovie.inc"
#INCLUDE "MMENGINE.INC"
DECLARE FUNCTION mciSendString LIB "WINMM.DLL" ALIAS "mciSendStringA" (lpstrCommand AS ASCIIZ, lpstrReturnString AS ASCIIZ, BYVAL uReturnLength AS DWORD, BYVAL hwndCallback AS DWORD) AS LONG

GLOBAL gbMoviePlaying, gnContainerW, gnContainerH, gbMuteMode, gbFullScreen AS LONG

' Interface pointers
'GLOBAL pIMediaControl  AS DWORD
'GLOBAL pIGraphBuilder  AS DWORD
'GLOBAL pIMediaEventEx  AS DWORD
'GLOBAL pIVideoWindow   AS DWORD
'GLOBAL pIBasicVideo    AS DWORD
'GLOBAL pIBasicAudio    AS DWORD
'GLOBAL pIMediaPosition AS DWORD

GLOBAL ghVideoHandle   AS LONG

DECLARE FUNCTION zMovieContainer (BYVAL hOwner AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL W AS LONG, BYVAL H AS LONG, BYVAL UseID AS LONG, BYVAL ARGB AS LONG) AS LONG

TYPE OPENFILENAME
    lStructSize       AS DWORD
    hWndOwner         AS DWORD
    hInstance         AS DWORD
    lpstrFilter       AS ASCIIZ PTR
    lpstrCustomFilter AS ASCIIZ PTR
    nMaxCustFilter    AS DWORD
    nFilterIndex      AS DWORD
    lpstrFile         AS ASCIIZ PTR
    nMaxFile          AS DWORD
    lpstrFileTitle    AS ASCIIZ PTR
    nMaxFileTitle     AS DWORD
    lpstrInitialDir   AS ASCIIZ PTR
    lpstrTitle        AS ASCIIZ PTR
    Flags             AS DWORD
    nFileOffset       AS WORD
    nFileExtension    AS WORD
    lpstrDefExt       AS ASCIIZ PTR
    lCustData         AS LONG
    lpfnHook          AS DWORD
    lpTemplateName    AS ASCIIZ PTR
END TYPE

DECLARE FUNCTION GetOpenFileName LIB "COMDLG32.DLL" ALIAS "GetOpenFileNameA" (lpofn AS OPENFILENAME) AS LONG

FUNCTION OpenFileDialog (BYVAL hWnd AS DWORD, _            ' parent window
                         BYVAL sCaption AS STRING, _       ' caption
                         sFileSpec AS STRING, _            ' filename
                         BYVAL sInitialDir AS STRING, _    ' start directory
                         BYVAL sFilter AS STRING, _        ' filename filter
                         BYVAL sDefExtension AS STRING, _  ' default extension
                         dFlags AS DWORD _                 ' flags
                        ) AS LONG

    LOCAL ix          AS LONG
    LOCAL ofn         AS OPENFILENAME
    LOCAL szFileTitle AS ASCIIZ * %MAX_PATH

    ' Filter is a sequence of ASCIIZ strings with a final (extra) $NUL terminator
    REPLACE "|" WITH $NUL IN sFilter
    sFilter = sFilter + $NUL

    IF LEN(sInitialDir) = 0 THEN
        sInitialDir = CURDIR$
    END IF

    ix = INSTR(sFileSpec, $NUL)
    IF ix THEN
        sFileSpec = LEFT$(sFileSpec, ix) + SPACE$(8192 - ix)
    ELSE
        sFileSpec = sFileSpec + $NUL + SPACE$(8192 - (LEN(sFileSpec) + 1))
    END IF

    ofn.lStructSize      = SIZEOF(ofn)
    ofn.hWndOwner        = hWnd
    ofn.lpstrFilter      = STRPTR(sFilter)
    ofn.nFilterIndex     = 1
    ofn.lpstrFile        = STRPTR(sFileSpec)
    ofn.nMaxFile         = LEN(sFileSpec)
    ofn.lpstrFileTitle   = VARPTR(szFileTitle)
    ofn.nMaxFileTitle    = SIZEOF(szFileTitle)
    ofn.lpstrInitialDir  = STRPTR(sInitialDir)
    IF LEN(sCaption) THEN
        ofn.lpstrTitle   = STRPTR(sCaption)
    END IF
    ofn.Flags            = dFlags
    IF LEN(sDefExtension) THEN
        ofn.lpstrDefExt  = STRPTR(sDefExtension)
    END IF

    FUNCTION = GetOpenFilename(ofn)

    ix = INSTR(-1, sFileSpec, $NUL)
    IF ix THEN
        sFileSpec = LEFT$(sFileSpec, ix - 1)
    ELSE
        sFileSpec = ""
    END IF

    dFlags = ofn.Flags

END FUNCTION

FUNCTION FileOpen (BYVAL hWnd AS DWORD) AS STRING

    LOCAL sPath    AS STRING
    LOCAL sOptions AS STRING
    LOCAL dwStyle  AS DWORD
    LOCAL sfile    AS STRING

    sPath  = CURDIR$
    sOptions = "Video Files (*.MPG;*MPEG;*.AVI;*.MOV;*.QT;*.WMV)|*.MPG;*.MPEG;*.AVI;*.MOV;*.QT;*.WMV|"
    sfile    = "*.MPG;*.MPEG;*.AVI;*.MOV;*.QT;*.WMV"
    dwStyle = &H00080000 OR &H00001000
    IF OpenFileDialog(hWnd, "", sfile, sPath, sOptions, "MPG", dwStyle) THEN
       FUNCTION = sfile
    END IF

END FUNCTION

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------
%WM_DROPFILES = &H233

DECLARE SUB DragAcceptFiles LIB "SHELL32.DLL" ALIAS "DragAcceptFiles" (BYVAL hwnd AS DWORD, BYVAL fAccept AS LONG)
DECLARE SUB DragFinish LIB "SHELL32.DLL" ALIAS "DragFinish" (BYVAL hDrop AS DWORD)
DECLARE FUNCTION DragQueryFile LIB "SHELL32.DLL" ALIAS "DragQueryFileA" (BYVAL hDrop AS DWORD, BYVAL uiFile AS DWORD, lpStr AS ASCIIZ, BYVAL cch AS DWORD) AS DWORD

%XMIN_SIZE = 546
%YMIN_SIZE = 384

%ID_AEROBUTTON       = 1
%ID_MOVIECONTAINER   = 2

%ID_BTN_PAUSE        = 3
%ID_BTN_PLAY         = 4

%ID_FULLSCREEN       = 5

%ID_TRACK_SEARCH     = 6
%ID_TRACK_VOL        = 7

%ID_TIME             = 8
%ID_DURATION         = 9
%ID_ELLAPSED         = 10

%ID_MUTE_ON          = 11
%ID_MUTE_OFF         = 12

%ID_AEROCRYSTAL      = 13
%ID_AEROBLUR         = 14
%ID_AERODISABLE      = 15
%ID_BTN_ABOUT        = 16
%ID_BTN_HELP         = 17
%ID_TITLE            = 18

%AERO_TIMER          = 1

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS LONG
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZMOVIEBOX"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          CALL PlayFromCommand(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL ' Don't paint the class window background
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
'
     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()
'
     ' Window Extended Style
       dwExStyle = 0
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "Template"
       hMain = CreateWindowEx(dwExStyle, _           ' Extended Style For The Window
                             zClass, _               ' Class Name
                             (MyTitle$), _           ' Window Title
                             dwStyle, _              ' Defined Window Style
                             x, y, _                 ' Window Position
                             rc.nRight - rc.nLeft, _ ' Calculate Window Width
                             rc.nBottom - rc.nTop, _ ' Calculate Window Height
                             %NULL, _                ' No Parent Window
                             %NULL, _                ' No Menu
                             wc.hInstance, _         ' Instance
                             BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(hMain, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(hMain, "MovieBox.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls(hMain)

'         // To perform movie file drag and drop
          CALL DragAcceptFiles(hMain, %TRUE)

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(5) ' 5 = UseStep for layered animation

          CALL PlayFromCommand(hMain)

          IF SK_AEROEMULATE() THEN CALL SetTimer(hMain, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(hMain, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND
          IF SK_AEROEMULATE() THEN CALL KillTimer(hMain, %AERO_TIMER)

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// To parse the command line when files are dropped onto the desktop icon
SUB PlayFromCommand(BYVAL hFound AS LONG)
    LOCAL K, S1, S2, Count, nCount AS LONG
    LOCAL sDataString AS STRING

    Cline$ = COMMAND$
    DO
       S1 = INSTR(Cline$, $DQ)
       IF S1 THEN
          S2 = INSTR(S1 + 1, Cline$, $DQ)
          IF S2 THEN
             sDataString = MID$(Cline$, S1 + 1, S2 - S1 - 1)
             REPLACE $SPC WITH CHR$(1) IN sDataString
             Cline$ = LEFT$(Cline$, S1 - 1) + sDataString + MID$(Cline$, S2 + 1)
             IF S2 > LEN(Cline$) THEN EXIT DO
          END IF
       ELSE
          REPLACE $SPC WITH CHR$(1) IN Cline$
          EXIT DO
       END IF
    LOOP
    REPLACE $SPC WITH $zLim IN Cline$
    REPLACE CHR$(1) WITH $SPC IN Cline$
    S1 = 1
    DO
       S1 = INSTR(S1, Cline$, $SPC)
       IF S1 THEN
          IF MID$(Cline$, S1 + 2, 2) = ":\" THEN MID$(Cline$, S1, 1) = $zLim
          S1 = S1 + 1
       END IF
    LOOP UNTIL S1 = 0
    Count = PARSECOUNT(Cline$, $zLim)
    IF Count THEN
       nCount = 0
       sDataString = ""
       FOR K = 1 TO Count
           sDataString = sDataString + $zLim + LCASE$(PARSE$(Cline$, $zLim, K)): INCR nCount
       NEXT
       IF nCount THEN
          CALL zSendPrivateMsg(hFound, %ZM_STRINGDATA, TRIM$(sDataString, $zLim))
       END IF
       sDataString = ""
    END IF

END SUB

'// Add child controls to main window
SUB AddChildControls(BYVAL hMain AS LONG)

    LOCAL hCtrl, imgW, imgH AS LONG

    hCtrl = zFrameButton(hMain, (SK_FOLDER() + "Aero.png"), "", 3, %YMIN_SIZE - 69, %XMIN_SIZE - 6, 66, %ID_AEROBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    CALL zGetImageSize(zGetProperty(hMain, %FORM_TopMid), 0, imgH)
    gnContainerW = %XMIN_SIZE - 6
    gnContainerH = %YMIN_SIZE - 69 - imgH
    hCtrl = zMovieContainer(hMain, 3, imgH, gnContainerW, gnContainerH, %ID_MOVIECONTAINER, zColorARGB(255, 0))
    CALL zSetAnchorMode(hCtrl, %ANCHOR_HEIGHT_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_TOP)

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Pause.png"), -100, -100, %ID_BTN_PAUSE, 0)
    CALL zGetImageSize(zGetButImageProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL ShowWindow(hCtrl, %SW_HIDE): CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    CALL MoveWindow(hCtrl, (%XMIN_SIZE - imgW) \ 2, %YMIN_SIZE - 56, imgW, imgH, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Pause")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Play.png"), -100, -100, %ID_BTN_PLAY, 0)
    CALL zGetImageSize(zGetButImageProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL MoveWindow(hCtrl, (%XMIN_SIZE - imgW) \ 2, %YMIN_SIZE - 56, imgW, imgH, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Play")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_FullScreen.png"), (%XMIN_SIZE - imgW) \ 2 - 30, %YMIN_SIZE - 44, %ID_FULLSCREEN, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Full screen")

    hCtrl = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 10, %YMIN_SIZE - 69, %XMIN_SIZE - 20, 14, %ID_TRACK_SEARCH, 0, 100, 0, SK_TRACKHICOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Search")

    IF Vista() THEN
       hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "AERO Crystal mode", 10, %YMIN_SIZE - 41, 130, 18, %ID_AEROCRYSTAL, SK_BTNTEXTCOLOR(), 0)
       CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
       CALL zSetZorder(hCtrl, %HWND_TOP)
       CALL zCreateToolTip(hCtrl, "Switch Skin display to CRYSTAL mode")

       hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "AERO Blur mode", 10, %YMIN_SIZE - 41 + 18, 130, 18, %ID_AEROBLUR, SK_BTNTEXTCOLOR(), 0)
       CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
       CALL zSetZorder(hCtrl, %HWND_TOP)
       CALL zCreateToolTip(hCtrl, "Switch Skin display to BLUR mode")
    END IF

    hCtrl = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 436, %YMIN_SIZE - 36, 100, 11, %ID_TRACK_VOL, 0, 1000, 500, SK_TRACKHICOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Change audio volume")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Mute_Off.png"), 409, %YMIN_SIZE - 43, %ID_MUTE_OFF, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Mute Off")
    CALL ShowWindow(hCtrl, %SW_HIDE)

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Mute_On.png"), 409, %YMIN_SIZE - 43, %ID_MUTE_ON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Mute On")

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(hMain, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(hMain, %ID_LED), %HWND_TOP)

'   // Use the Skin's name for caption
    CALL zSetCTLText(hMain, (PARSE$(SK_AUTHOR(), $zLim, 1)))

    hCtrl = zStaticLabel(hMain, TIME$, 10, %YMIN_SIZE - 56, 54, 15, %ID_TIME, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL EnableWindow(hCtrl, %TRUE): CALL zCreateToolTip(hCtrl, "Current time")

    hCtrl = zStaticLabel(hMain, "00:00:00", %XMIN_SIZE - 112, %YMIN_SIZE - 56, 54, 15, %ID_DURATION, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL EnableWindow(hCtrl, %TRUE): CALL zCreateToolTip(hCtrl, "Movie duration")

    hCtrl = zStaticLabel(hMain, "00:00:00", %XMIN_SIZE - 57, %YMIN_SIZE - 56, 54, 15, %ID_ELLAPSED, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL EnableWindow(hCtrl, %TRUE): CALL zCreateToolTip(hCtrl, "Movie ellapsed")

    hCtrl = zPushButton(hMain, (SK_FOLDER() + "BTN_About.png"), "", %XMIN_SIZE - 105, %YMIN_SIZE - 22, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Help.png"), 7, 4, %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

    hCtrl = zStaticLabel(hMain, "", 29, 24, 440, 15, %ID_TITLE, SK_INACTIVECAPTION(), %BS_LABEL_LEFT)

END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT
    LOCAL sDataString AS STRING, hDC, dwData, hFound, ARGBcolor AS LONG
    LOCAL szFileName AS ASCIIZ * %MAX_PATH
    LOCAL Alpha, Red, Green, Blue AS BYTE

    STATIC IsMoving, IsMaximized, nACTIVECAPTION, nINACTIVECAPTION AS LONG

    SELECT CASE LONG Msg
    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_DROPFILES '// Drag & drop
         LOCAL nFilesDropped AS LONG
         CALL SetForegroundWindow(hWnd)
         CALL zUpdateWindow(hWnd, %TRUE)
         nFilesDropped = DragQueryFile(wParam, -1, "", 0)
         szFileName = ""
         IF nFilesDropped > 0 THEN
            CALL DragQueryFile(wParam, 0, szFileName, %MAX_PATH)
            szFileName = LCASE$(szFileName)
         END IF
         CALL DragFinish(wParam)
         CALL CheckMovieName(szFileName)

    CASE %WM_COPYDATA
       ' wParam holds the string length
       ' lParam holds the Byte array address
         dwData = zGetPrivateMsg(sDataString, wParam, lParam)
         szFileName = ""
         IF dwData = %ZM_STRINGDATA THEN
            IF LEN(sDataString) THEN szFileName = LCASE$(PARSE$(sDataString, $zLim, 1))
         END IF
         CALL CheckMovieName(szFileName)
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LOWRD(wParam)

         CASE %ID_BTN_PLAY
              IF gbMoviePlaying THEN
                 CALL MoviePlay()
              ELSE
                 szFileName = LCASE$(FileOpen(hWnd))
                 IF LEN(szFileName) THEN CALL CheckMovieName(szFileName)
              END IF

         CASE %ID_BTN_PAUSE
              IF gbMoviePlaying THEN CALL MoviePause()

         CASE %ID_MUTE_OFF
              CALL ShowWindow(zGetMainItem(%ID_MUTE_OFF), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_MUTE_OFF), %HWND_BOTTOM)
              CALL ShowWindow(zGetMainItem(%ID_MUTE_ON), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_MUTE_ON), %HWND_TOP)
              gbMuteMode = 0
              CALL MMSetVolume(zGetTrackValue(zGetMainItem(%ID_TRACK_VOL)))

         CASE %ID_MUTE_ON
              CALL ShowWindow(zGetMainItem(%ID_MUTE_ON), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_MUTE_ON), %HWND_BOTTOM)
              CALL ShowWindow(zGetMainItem(%ID_MUTE_OFF), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_MUTE_OFF), %HWND_TOP)
              gbMuteMode = -1
              CALL MMSetVolume(0)

         CASE %ID_FULLSCREEN
              gbFullScreen = NOT gbFullScreen
              CALL zREMOVEBORDER(gbFullScreen, 1)
              IF gbFullScreen THEN
                 CALL zPAINTBACKCOLOR(zColorARGB(255, 0), 1)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_HELP), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_RESTORE), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_MAXIMIZE), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_CLOSE), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_MINIMIZE), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_LED), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_ABOUT), %SW_HIDE)

                 CALL ShowWindow(zGetMainItem(%ID_AEROBUTTON), %SW_HIDE)

                 IF Vista() THEN
                    CALL ShowWindow(zGetMainItem(%ID_AEROCRYSTAL), %SW_HIDE)
                    CALL ShowWindow(zGetMainItem(%ID_AEROBLUR), %SW_HIDE)
                 END IF

                 CALL zSplitColorARGB(SK_BTNTEXTCOLOR(), Alpha, Red, Green, Blue)
                 ARGBcolor = zColorARGB(64, RGB(Red, Green, Blue))
                 CALL zSetImageProperty(zGetMainItem(%ID_TIME), %PROP_TEXT_COLOR, ARGBColor)
                 CALL zSetImageProperty(zGetMainItem(%ID_DURATION), %PROP_TEXT_COLOR, ARGBColor)
                 CALL zSetImageProperty(zGetMainItem(%ID_ELLAPSED), %PROP_TEXT_COLOR, ARGBColor)

                 nACTIVECAPTION  = SK_ACTIVECAPTION()
                 nINACTIVECAPTION = SK_INACTIVECAPTION()
                 CALL zSplitColorARGB(nACTIVECAPTION, Alpha, Red, Green, Blue)
                 gColorCaption = zColorARGB(16, RGB(Red, Green, Blue))
                 CALL zACTIVECAPTION(gColorCaption, %WRITE)
                 CALL zINACTIVECAPTION(gColorCaption, %WRITE)

                 IsMaximized = IsZoomed(hWnd)
                 IF IsMaximized = 0 THEN
                    CALL ShowWindow(hWnd, %SW_MAXIMIZE)
                 END IF
              ELSE
                 CALL ShowWindow(zGetMainItem(%ID_BTN_HELP), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_CLOSE), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_MINIMIZE), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_LED), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_ABOUT), %SW_SHOW)

                 CALL ShowWindow(zGetMainItem(%ID_AEROBUTTON), %SW_SHOW)

                 IF Vista() THEN
                    CALL ShowWindow(zGetMainItem(%ID_AEROCRYSTAL), %SW_SHOW)
                    CALL ShowWindow(zGetMainItem(%ID_AEROBLUR), %SW_SHOW)
                 END IF

                 CALL zSetImageProperty(zGetMainItem(%ID_TIME), %PROP_TEXT_COLOR, SK_BTNTEXTCOLOR())
                 CALL zSetImageProperty(zGetMainItem(%ID_DURATION), %PROP_TEXT_COLOR, SK_BTNTEXTCOLOR())
                 CALL zSetImageProperty(zGetMainItem(%ID_ELLAPSED), %PROP_TEXT_COLOR, SK_BTNTEXTCOLOR())

                 CALL zACTIVECAPTION(nACTIVECAPTION, %WRITE)
                 CALL zINACTIVECAPTION(nINACTIVECAPTION, %WRITE)
                 gColorCaption = nACTIVECAPTION

                 IF IsMaximized THEN
                    CALL ShowWindow(zGetMainItem(%ID_RESTORE), %SW_SHOW)
                    CALL ShowWindow(zGetMainItem(%ID_MAXIMIZE), %SW_HIDE)
                 ELSE
                    CALL ShowWindow(hWnd, %SW_RESTORE)

                    CALL ShowWindow(zGetMainItem(%ID_MAXIMIZE), %SW_SHOW)
                    CALL ShowWindow(zGetMainItem(%ID_RESTORE), %SW_HIDE)
                 END IF
              END IF
              CALL zDrawBackground()
              CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), 0)
              CALL zUpdateWindow(hWnd, 0)
              IF ghVideoHandle THEN CALL zUpdateWindow(ghVideoHandle, 0)

         CASE %ID_TRACK_SEARCH
              LOCAL IsInPauseMode AS LONG
              IF gbMoviePlaying AND IsWindowVisible(zGetMainItem(%ID_BTN_PLAY)) THEN IsInPauseMode = -1
              CALL MMMove(lParam * 100, IsInPauseMode)

         CASE %ID_TRACK_VOL
              CALL MMSetVolume(lParam)

         CASE %ID_AEROCRYSTAL
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
'//                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(0, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%TRUE, %WRITE)
                 CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

              ELSE
                 CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_AEROBLUR
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
'//                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(6, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
                 CALL zUSEVISTABLUR(%TRUE, %WRITE)
                 CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

              ELSE
                 CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_AERODISABLE
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE)) THEN
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%FALSE, %WRITE)
                 CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop)
                 CALL zUpdateWindow(hWnd, 0)
              ELSE
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)
              END IF
'         CASE %ID_TRACK_OPACITY
'              IF SK_AEROEMULATE() THEN
'                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
'                 CALL zAEROCOLOR(zColorARGB(lParam, RGB(Red, Green, Blue)), %WRITE)
'                 CALL GetWindowRect(hWnd, rc)
'                 CALL zMoveBackground(rc.nLeft, rc.nTop)
'                 CALL zUpdateWindow(hWnd, 0)
'              END IF
         CASE %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION
         CASE %ID_BTN_HELP
              sDataString = zsExePath() + "MovieBox.chm"
              IF zsExist((sDataString)) THEN
                 hFound = FindWindow("HH Parent", "MovieBox")
                 IF hFound THEN
                    IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
                 ELSE
                    CALL ShellExecute(BYVAL 0, "open", (sDataString), "", "", %SW_SHOW)
                 END IF
              END IF
         END SELECT

    CASE %WM_SIZE
         CALL zDrawBackground()
         CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
         CALL zUpdateWindow(hWnd, 0)

         IF ghVideoHandle THEN
            CALL GetClientRect(zGetMainItem(%ID_MOVIECONTAINER), rc)
            CALL MoveWindow(ghVideoHandle, rc.nLeft, rc.nTop, rc.nRight, rc.nBottom, 0)
            CALL zUpdateWindow(ghVideoHandle, 0)
         END IF

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground()
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG, p AS POINTAPI
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut, RedrawVideo AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            RedrawVideo = 0
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
               IF ghVideoHandle THEN RedrawVideo = -1
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground()

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)

            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            ' We must do that for XP, to force a complete redraw of the video section
            IF RedrawVideo THEN CALL zUpdateWindow(ghVideoHandle, 1)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
'        // If there is a movie playing then stop it
         CALL MovieClose()

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

'        //START AERO section ---------------------------------------------------------
         CASE %WM_TIMER
              IF zDwmIsCompositionEnabled() = 0 THEN
                 IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
                    IF zIsLButtonDown() = 0 THEN IsMoving = 0
                    IF IsMoving = 0 OR (zIsLButtonDown() AND IsMoving) THEN
                       CALL GetWindowRect(hWnd, rc)
                       CALL zMoveBackground(rc.nLeft, rc.nTop)
                       CALL zUpdateWindow(hWnd, 0)
                    END IF
                 END IF
              END IF

         CASE %WM_NCLBUTTONDOWN
              IsMoving = -1

         CASE %WM_MOVING
              IF zDwmIsCompositionEnabled() = 0 THEN
                 IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
                    DIM rw AS RECT PTR
                    rw = lparam
                    CALL zMoveBackground(@rw.nLeft,@rw.nTop)
                    CALL zUpdateWindow(hWnd, 0)
                    FUNCTION = 1: EXIT FUNCTION
                 END IF
              END IF
'        //END AERO section ---------------------------------------------------------

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

'------------------------------------------------------------------------------------------
' Movie section
'------------------------------------------------------------------------------------------

SUB CheckMovieName(zFileName AS ASCIIZ)
    IF LEN(zFileName) THEN
       LOCAL So AS LONG, sExt AS STRING
       So = INSTR(-1, zFileName, $Dot)
       IF So THEN
          sExt = LCASE$(MID$(zFileName, So))
          IF INSTR($MOVIEXT, sExt + $Dot) THEN
             CALL MoviePlayNewMedia(zFileName)
          END IF
       END IF
    END IF
END SUB

FUNCTION MovieToTime(BYVAL MovieLocation AS DOUBLE) AS STRING
    LOCAL HH, MM, SS AS LONG

    HH = MovieLocation \ 3600
    MM = (MovieLocation - HH * 3600) \ 60
    SS = MovieLocation - HH * 3600 - MM * 60

    L$ = ":"
    FUNCTION  = RIGHT$("00" + LTRIM$(STR$(HH)), 2) + L$ + _
                RIGHT$("00" + LTRIM$(STR$(MM)), 2) + L$ + _
                RIGHT$("00" + LTRIM$(STR$(SS)), 2)

END FUNCTION

'// We handle the movie container control messages there
FUNCTION MovieProc (BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

    SELECT CASE LONG Msg

    CASE %WM_TIMER
         LOCAL MovieLocation AS DOUBLE, tLocation AS LONG
         CALL zSetCTLText(zGetMainItem(%ID_TIME), TIME$)
                
         CALL zSetCTLText(zGetMainItem(%ID_ELLAPSED), MovieToTime(MMGetCurrentPos / 1000))
         CALL zSetTrackValue(zGetMainItem(%ID_TRACK_SEARCH), MMGetCurrentPos() / 100)
         IF gbMoviePlaying THEN
            IF zGetCTLText(zGetMainItem(%ID_ELLAPSED)) = zGetCTLText(zGetMainItem(%ID_DURATION)) THEN
               CALL MovieClose()
            END IF
         END IF

    CASE %WM_DESTROY
         CALL KillTimer(hWnd, 1)

    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

'// Create a Movie container control
FUNCTION zMovieContainer (BYVAL hOwner AS LONG, _
                          BYVAL x AS LONG, BYVAL y AS LONG, BYVAL W AS LONG, BYVAL H AS LONG, BYVAL UseID AS LONG, _
                          BYVAL ARGB AS LONG) AS LONG
    LOCAL wc  AS WNDCLASSEX
    LOCAL zClass AS ASCIIZ * 16
    LOCAL hCtrl, IsInitialized, dwStyle AS LONG

    zClass = "ZMOVIECONTAINER"
    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance, zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS OR %CS_PARENTDC
       wc.lpfnWndProc   = CODEPTR(MovieProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance
       wc.hIcon         = %NULL ' LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL ' Don't paint the class window background
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
       dwStyle = %WS_CHILD OR %WS_VISIBLE
       hCtrl = CreateWindowEx(0, zClass, "", dwStyle, x, y, W, H, hOwner, UseID, zsInstance, BYVAL %NULL)
       CALL zSetImageProperty(hCtrl, %PROP_STYLE, %FILLRECTANGLE)
       CALL zSetImageProperty(hCtrl, %PROP_COLOR, ARGB)
       CALL SetTimer(hCtrl, 1, 1000, %NULL)
       CALL zSetZorder(hCtrl, %HWND_BOTTOM)
       ' Enable drag background to force XP to redraw the whole video window
       CALL zDRAG_BACKGROUND(1, 1)
       FUNCTION = hCtrl
    END IF
END FUNCTION

SUB MovieClose()
    CALL MMClose() ' CloseMedia
    gbMoviePlaying = 0
    CALL zSetCTLText(zGetMainItem(%ID_DURATION), "00:00:00")
    CALL zSetCTLText(zGetMainItem(%ID_ELLAPSED), "00:00:00")
    CALL ShowWindow(zGetMainItem(%ID_BTN_PAUSE), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_BTN_PAUSE), %HWND_BOTTOM)
    CALL ShowWindow(zGetMainItem(%ID_BTN_PLAY), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_BTN_PLAY), %HWND_TOP)
    CALL zSetCTLText(zGetMainItem(%ID_TITLE), "")

END SUB

SUB MoviePlay()
    CALL ShowWindow(zGetMainItem(%ID_BTN_PLAY), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_BTN_PLAY), %HWND_BOTTOM)
    CALL ShowWindow(zGetMainItem(%ID_BTN_PAUSE), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_BTN_PAUSE), %HWND_TOP)
    CALL MMResume()
    gbMoviePlaying = -1
END SUB

SUB MoviePause()
    CALL ShowWindow(zGetMainItem(%ID_BTN_PAUSE), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_BTN_PAUSE), %HWND_BOTTOM)
    CALL ShowWindow(zGetMainItem(%ID_BTN_PLAY), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_BTN_PLAY), %HWND_TOP)
    CALL MMPause()
END SUB

SUB MoviePlayNewMedia(zThisMovie AS ASCIIZ)

    LOCAL sVideoCaption AS STRING, hParent, nRetLNG, lWidth, lHeight, InZoomMode AS LONG

    '// I must check it there,
    '// because IsZoomed is not reliable when used after calling the IVideoWindowInterface.
    InZoomMode = IsZoomed(zMainWindow(0))

    hParent = zGetMainItem(%ID_MOVIECONTAINER)

    ' If there is a movie playing then stop it
    CALL MovieClose()

    ' Render the file
    IF MMOpen(hParent, zThisMovie) = 0 THEN

       ' Get the true Video window handle
       CALL MMGetWindowHandle(ghVideoHandle)

       ' Retrieve the real video size
       CALL MMGetSize(lWidth, lHeight)

       ' Detect HD movie
       IF lWidth > 1199 THEN
          lWidth = lWidth \ 2
          lHeight = lHeight \ 2
       END IF

       ' Adjust the main window to match the movie size
       LOCAL rc, rw AS RECT, UseW, UseH, DeltaX, DeltaY, So AS LONG
       LOCAL Aspect AS SINGLE, sMovieName AS STRING

       UseW = lWidth: UseH = lHeight
       IF UseW < gnContainerW THEN Aspect = gnContainerW / UseW: UseW = UseW * Aspect: UseH = UseH * Aspect
       IF UseH < gnContainerH THEN Aspect = gnContainerH / UseH: UseW = UseW * Aspect: UseH = UseH * Aspect

       CALL GetClientRect(hParent, rc)
       IF InZoomMode THEN
          UseW = rc.nRight: UseH = rc.nBottom
       ELSE
          DeltaX = rc.nRight - UseW
          DeltaY = rc.nBottom - UseH
          CALL GetWindowRect(zMainWindow(0), rw)
          CALL MoveWindow(zMainWindow(0), rw.nLeft , rw.nTop, rw.nRight - rw.nLeft - DeltaX, rw.nBottom -rw.nTop - DeltaY, %TRUE)
       END IF
       ' Resize the DirectX window
       CALL MoveWindow(ghVideoHandle, 0, 0, UseW, UseH, 0)

       ' Setup the video Audio level
       IF gbMuteMode THEN
          CALL MMSetVolume(0)
       ELSE
          CALL MMSetVolume(zGetTrackValue(zGetMainItem(%ID_TRACK_VOL)))
       END IF

       LOCAL MovieDuration AS DOUBLE, tMax AS LONG
       MovieDuration = MMGetTotalTimeByMS() / 1000

       tMax = MovieDuration * 10
       CALL zSetCTLText(zGetMainItem(%ID_DURATION), MovieToTime(MovieDuration))
       CALL zSetTrackMinMax(zGetMainItem(%ID_TRACK_SEARCH), 0, tMax)
       CALL zSetTrackValue(zGetMainItem(%ID_TRACK_SEARCH), 0)

       CALL zSplitN(zThisMovie, "", sMovieName)
       So = INSTR(-1, sMovieName, $Dot): IF So THEN sMovieName = LEFT$(sMovieName, So - 1)
       sMovieName = UCASE$(LEFT$(sMovieName, 1)) + MID$(sMovieName, 2)
       CALL zSetCTLText(zGetMainItem(%ID_TITLE), (sMovieName))

       ' Run the movie
       CALL MMPlay(0, 0)
       CALL MoviePlay()
    END IF

END SUB
